<app-loading *ngIf="isLoadingPage"></app-loading>
<form nz-form [formGroup]="form">
    <div nz-row [nzGutter]="[30, 10]">

        <!-- Từ ngày -->
        <div nz-col [nzXs]="24" [nzLg]="12">
            <mb-date-picker
                formControlName="fromDate"
                mbLabelText="{{'staffManager.workHisInformation.label.attributes.fromDate' | translate}}  <span class='label__required'>*</span>"
                mbPlaceholderText="{{'staffManager.workHisInformation.label.attributes.fromDate' | translate}}"

                [mbType]="(isSubmitted && form.controls['fromDate'].errors || form.errors?.rangeDateError1) ? 'error' : 'default'"
                [mbShowError]="(isSubmitted && form.controls['fromDate'].errors || form.errors?.rangeDateError1) !== null"
                [mbErrors]="form.errors?.rangeDateError1 ? form.errors : form.controls['fromDate'].errors"
                [mbErrorDefs]="[
                    { errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param':'staffManager.workHisInformation.label.attributes.fromDate' | translate }},
                    { errorName: 'rangeDateError1', errorDescription: 'staffManager.validate.rangeDate.pareDate' | translate:
                {'fromDate': 'staffManager.workHisInformation.label.attributes.fromDate' | translate, 'toDate': 'staffManager.workHisInformation.label.attributes.toDate' | translate}}
                 ]"
            ></mb-date-picker>
        </div>

        <!-- Loại quyết định -->
        <div nz-col [nzXs]="24" [nzLg]="12">
            <mb-select
                [mbDataSelects]="listDocumentType"
                (ngModelChange)="changeValue($event)"
                mbKeyLabel="name"
                mbKeyValue="documentTypeId"

                formControlName="documentTypeId"
                mbLabelText="{{'staffManager.workHisInformation.label.attributes.documentType' | translate}} <span class='label__required'>*</span>"
                mbPlaceholder="{{'staffManager.workHisInformation.label.attributes.documentType' | translate}}"

                [mbType]="isSubmitted && form.controls['documentTypeId'].errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && form.controls['documentTypeId'].errors !== null"
                [mbErrors]="form.controls['documentTypeId'].errors"
                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param':'staffManager.workHisInformation.label.attributes.documentType' | translate }}]"
            ></mb-select>
        </div>

        <!-- Loại đối tượng -->
        <div nz-col [nzXs]="24" [nzLg]="12" [ngClass]="{'hide-when-type-out': isHideWhenTypeOut}">
            <mb-select
                [mbDataSelects]="listEmpType"
                mbKeyLabel="label"
                mbKeyValue="value"

                formControlName="empTypeCode"
                mbLabelText="{{'staffManager.workHisInformation.label.attributes.empType' | translate}} <span class='label__required'>*</span>"
                mbPlaceholder="{{'staffManager.workHisInformation.label.attributes.empType' | translate}}"

                [mbType]="isSubmitted && form.controls['empTypeCode']?.errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && form.controls['empTypeCode']?.errors !== null"
                [mbErrors]="form.controls['empTypeCode']?.errors"
                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.workHisInformation.label.attributes.empType' | translate}}]"
            ></mb-select>
        </div>

        <!-- ID Đơn vị -->
        <div nz-col [nzXs]="24" [nzLg]="12" [ngClass]="{'hide-when-type-out': isHideWhenTypeOut}">
            <org-data-picker
                [functionCode]="functionCode"
                formControlName="organizationId"
                mbLabelText="{{'staffManager.workHisInformation.label.attributes.organization' | translate}} <span class='label__required'>*</span>"

                [mbType]="isSubmitted && form.controls['organizationId']?.errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && form.controls['organizationId']?.errors !== null"
                [mbErrors]="form.controls['organizationId']?.errors"
                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.workHisInformation.label.attributes.organization' | translate}}]"
            ></org-data-picker>
        </div>

        <!-- Chức danh -->
        <div nz-col [nzXs]="24" [nzLg]="12" [ngClass]="{'hide-when-type-out': isHideWhenTypeOut}">
            <mb-select
                [mbDataSelects]="listPosition"
                mbKeyLabel="jobName"
                mbKeyValue="posId"

                formControlName="positionId"
                mbLabelText="{{'staffManager.workHisInformation.label.attributes.position' | translate}} <span class='label__required'>*</span>"
                mbPlaceholder="{{'staffManager.workHisInformation.label.attributes.position' | translate}}"
                (mbEventEmit)="changePosition($event)"
                [mbType]="isSubmitted && form.controls['positionId']?.errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && form.controls['positionId']?.errors !== null"
                [mbErrors]="form.controls['positionId']?.errors"
                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate:{'param': 'staffManager.workHisInformation.label.attributes.position' | translate} }]"
            ></mb-select>
        </div>

        <!-- Bậc Chức danh -->
        <div nz-col [nzXs]="24" [nzLg]="12" [ngClass]="{'hide-when-type-out': isHideWhenTypeOut}">
            <mb-select
                [mbDataSelects]="listPositionLevel"
                mbKeyLabel="label"
                mbKeyValue="value"

                formControlName="positionLevel"
                mbLabelText="{{'staffManager.workHisInformation.label.attributes.positionLevel' | translate}}"
                mbPlaceholder="{{'staffManager.workHisInformation.label.attributes.positionLevel' | translate}}"
            ></mb-select>
        </div>

        <!--Nhóm vị trí -->
        <div nz-col [nzXs]="24" [nzLg]="12" [ngClass]="{'hide-when-type-out': isHideWhenTypeOut}">
            <mb-select
                [mbDataSelects]="listPositionGroup"
                formControlName="positionGroupId"
                mbLabelText="{{'staffManager.workHisInformation.label.attributes.positionGroup' | translate}} <span class='label__required'>*</span>"
                mbPlaceholder="{{'staffManager.workHisInformation.label.attributes.positionGroup' | translate}}"
                [mbType]="isSubmitted && form.controls['positionGroupId']?.errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && form.controls['positionGroupId']?.errors !== null"
                [mbErrors]="form.controls['positionGroupId']?.errors"
                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate:{'param': 'staffManager.workHisInformation.label.attributes.positionGroup' | translate} }]"
            ></mb-select>
        </div>

        <!-- Số quyết định -->
        <div nz-col [nzXs]="24" [nzLg]="12">
            <mb-input-text
                formControlName="documentNo"
                mbLabelText="{{'staffManager.workHisInformation.label.attributes.documentNo' | translate}}"
                mbPlaceholderText="{{'staffManager.workHisInformation.label.attributes.documentNo' | translate}}"

                [mbType]="isSubmitted && form.controls['documentNo'].errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && form.controls['documentNo'].errors !== null"
                [mbErrors]="form.controls['documentNo'].errors"
                [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'staffManager.validate.maxLength' | translate: {'numberLength': '50' }}]"
            ></mb-input-text>
        </div>

        <!-- Ngày ký QĐ -->
        <div nz-col [nzXs]="24" [nzLg]="12">
            <mb-date-picker
                formControlName="signedDate"
                mbLabelText="{{'staffManager.workHisInformation.label.attributes.signedDate' | translate}}"
                mbPlaceholderText="{{'staffManager.workHisInformation.label.attributes.signedDate' | translate}}"

                [mbType]="isSubmitted && form.controls['signedDate'].errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && form.controls['signedDate'].errors !== null"
                [mbErrors]="form.controls['signedDate'].errors"
                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required'}]"
            ></mb-date-picker>
        </div>

        <!-- Thử thách -->
        <div nz-col [nzXs]="24" [nzLg]="24" *ngIf="documentType?.isShowTrial">
            <label
                style="padding: 10px 0;"
                nz-checkbox
                formControlName="isTrial"
            >{{ 'staffManager.workHisInformation.label.attributes.trial' | translate}}</label>
        </div>

        <!-- Ngày kết thúc 1 -->
        <div nz-col [nzXs]="24" [nzLg]="12" *ngIf="documentType?.isShowEndDate">
            <mb-date-picker
                [required]="documentType?.isRequiredEndDate"
                formControlName="planToDate1"
                mbLabelText="{{ 'staffManager.workHisInformation.label.attributes.toDate' | translate}}"
                mbPlaceholderText="{{'staffManager.workHisInformation.label.attributes.toDate' | translate}}"

                [mbType]="(isSubmitted && form.controls['planToDate1'].errors || form.errors?.rangeDateError2) ? 'error' : 'default'"
                [mbShowError]="(isSubmitted && form.controls['planToDate1'].errors || form.errors?.rangeDateError2) !== null"
                [mbErrors]="form.errors?.rangeDateError2 ? form.errors : form.controls['planToDate1'].errors"
                [mbErrorDefs]="[
                    { errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param':'staffManager.workHisInformation.label.attributes.toDate' | translate }},
                    { errorName: 'rangeDateError2', errorDescription: 'staffManager.validate.rangeDate.pareDate' | translate:
                {'fromDate': 'staffManager.workHisInformation.label.attributes.toDate' | translate, 'toDate': 'staffManager.workHisInformation.label.attributes.toDate2' | translate}}
                 ]"
            ></mb-date-picker>
        </div>

        <!-- Ngày kết thúc 2 -->
        <div nz-col [nzXs]="24" [nzLg]="12" *ngIf="documentType?.isShowEndDate">
            <mb-date-picker
                [required]="documentType?.isRequiredEndDate"
                formControlName="planToDate2"
                mbLabelText="{{'staffManager.workHisInformation.label.attributes.toDate2' | translate}}"
                mbPlaceholderText="{{'staffManager.workHisInformation.label.attributes.toDate2' | translate}}"

                [mbType]="isSubmitted && form.controls['planToDate2'].errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && form.controls['planToDate2'].errors !== null"
                [mbErrors]="isSubmitted && form.controls['planToDate2'].errors"
                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param':'staffManager.workHisInformation.label.attributes.toDate2' | translate }}]"
            ></mb-date-picker>
        </div>

        <!-- Bảo lưu thâm niên -->
        <div nz-col [nzXs]="24" [nzLg]="24" *ngIf="documentType?.isShowKeepSenior">
            <label
                nz-checkbox
                formControlName="isKeepSenior"
            >{{'staffManager.workHisInformation.label.attributes.keepSenior' | translate}}</label>
        </div>

        <div nz-col [nzXs]="24" [nzLg]="12"></div>

        <!-- Quá trình kiêm nhiệm -->
        <extend-form-item
            *ngIf="isShowConcurrentProcess"
            [ngClass]="{'hide-when-type-out': isHideWhenTypeOut}"
            class="concurrentProcess"
            nz-col [nzXs]="24" [nzLg]="24"
        >
            <ng-container formArrayName="listConcurrentProcessDTO">
                <ng-container
                    *ngFor="let concurProcess of concurrentProcesses?.controls; let i = index; let first = first">

                    <div class="concurrentProcessHeader">
                        <div
                            class="concurrentProcessHeaderTitle">{{'staffManager.workHisInformation.label.attributes.concurrentProcess' | translate}} {{i + 1}}</div>
                        <div class="concurrentProcessAction">
                            <mb-button
                                (click)="addConcurrentProcess(i)"
                                mbButtonIconType="AWESOME" mbPrefixIcon="far fa-plus-circle"
                                mbButtonSize="SMALL"
                                mbButtonTextColor="#141ED2" mbButtonType="NO_BORDER"></mb-button>

                            <mb-button
                                (click)="removeConcurrentProcess(i)"
                                mbButtonIconType="AWESOME" mbPrefixIcon="far fa-trash-alt"
                                mbButtonSize="SMALL"
                                mbButtonTextColor="#FA0B0B" mbButtonType="NO_BORDER"></mb-button>
                        </div>
                    </div>
                    <nz-divider class="divider"></nz-divider>

                    <div nz-row [nzGutter]="[30, 30]" [formGroupName]="i"
                         [ngClass]="{'isHide': isHideConcurrentProcess}">

                        <!-- Đối tượng CV * -->
                        <div nz-col [nzXs]="12" [nzLg]="12" class="otherEmpTypeCode">
                            <mb-select
                                [mbDataSelects]="listEmpType"
                                mbKeyLabel="label"
                                mbKeyValue="value"

                                [mbType]="isSubmitted && concurProcess.controls['otherEmpTypeCode']?.errors ? 'error' : 'default'"
                                [mbShowError]="isSubmitted && concurProcess.controls['otherEmpTypeCode']?.errors !== null"
                                [mbErrors]="concurProcess.controls['otherEmpTypeCode']?.errors"
                                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.workHisInformation.label.attributes.empType' | translate}}]"

                                mbPlaceholder="{{'staffManager.workHisInformation.label.attributes.empType' | translate}}"
                                mbLabelText="{{'staffManager.workHisInformation.label.attributes.empType' | translate}} <span class='label__required'>*</span>"
                                formControlName="otherEmpTypeCode"
                            ></mb-select>
                        </div>

                        <!-- Đơn vị * -->
                        <div nz-col [nzXs]="12" [nzLg]="12" class="otherOrgId">
                            <org-data-picker
                                [mbType]="isSubmitted && concurProcess.controls['otherOrgId']?.errors ? 'error' : 'default'"
                                [mbShowError]="isSubmitted && concurProcess.controls['otherOrgId']?.errors !== null"
                                [mbErrors]="concurProcess.controls['otherOrgId']?.errors"
                                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.workHisInformation.label.attributes.organization' | translate}}]"

                                mbLabelText="{{'staffManager.workHisInformation.label.attributes.organization' | translate}} <span class='label__required'>*</span>"
                                mbPlacholder="{{'staffManager.workHisInformation.label.common.searchOtherOrg' | translate }}"
                                (ngModelChange)="onOtherOrgChange($event)"
                                formControlName="otherOrgId"
                            ></org-data-picker>
                        </div>

                        <!-- Chức danh * -->
                        <div nz-col [nzXs]="12" [nzLg]="12">
                            <mb-select
                                [mbDataSelects]="listOtherPosition"
                                mbKeyLabel="jobName"
                                mbKeyValue="posId"

                                [mbType]="isSubmitted && concurProcess.controls['otherPositionId']?.errors ? 'error' : 'default'"
                                [mbShowError]="isSubmitted && concurProcess.controls['otherPositionId']?.errors !== null"
                                [mbErrors]="concurProcess.controls['otherPositionId']?.errors"
                                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.workHisInformation.label.attributes.otherPosition' | translate}}]"

                                mbPlaceholder="{{'staffManager.workHisInformation.label.attributes.otherPosition' | translate}}"
                                mbLabelText="{{'staffManager.workHisInformation.label.attributes.position' | translate}} <span class='label__required'>*</span>"
                                formControlName="otherPositionId"
                            ></mb-select>
                        </div>

                        <!-- Người quản lý trực tiếp -->
                        <div nz-col [nzXs]="12" [nzLg]="12">
                            <employee-data-picker
                                [mbCanText]="true"
                                mbLabelText="{{'staffManager.workHisInformation.label.attributes.directManager' | translate}}"
                                formControlName="otherManagerId"
                            >
                            </employee-data-picker>
                        </div>

                        <!-- Có thử thách? -->
                        <div nz-col [nzXs]="12" [nzLg]="12" class="otherIsTrial">
                            <label
                                nz-checkbox
                                formControlName="otherIsTrial"
                            >{{ 'staffManager.workHisInformation.label.attributes.trial' | translate}}</label>
                        </div>

                        <div nz-col [nzXs]="12" [nzLg]="12"></div>

                        <!-- Ngày kết thúc 1 -->
                        <div nz-col [nzXs]="12" [nzLg]="12" class="otherPlanToDate1">
                            <mb-date-picker
                                [mbType]="(isSubmitted && concurProcess.controls['otherPlanToDate1']?.errors || concurrentProcesses.errors?.rangeDateErrorOther) ? 'error' : 'default'"
                                [mbShowError]="(isSubmitted && concurProcess.controls['otherPlanToDate1']?.errors || concurProcess.errors?.rangeDateErrorOther) !== null"
                                [mbErrors]="concurProcess.errors?.rangeDateErrorOther ? concurProcess.errors : concurProcess.controls['otherPlanToDate1']?.errors"
                                [mbErrorDefs]="[
                                    { errorName: 'rangeDateErrorOther', errorDescription: 'staffManager.validate.rangeDate.pareDate' | translate:{'fromDate': 'staffManager.workHisInformation.label.attributes.toDate' | translate, 'toDate': 'staffManager.workHisInformation.label.attributes.toDate2' | translate}}
                                ]"
                                mbPlaceholderText="{{'staffManager.workHisInformation.label.attributes.toDate' | translate}}"
                                mbLabelText="{{'staffManager.workHisInformation.label.attributes.toDate' | translate}}"
                                formControlName="otherPlanToDate1"
                            ></mb-date-picker>
                        </div>

                        <!-- Ngày kết thúc 2 -->
                        <div nz-col [nzXs]="12" [nzLg]="12" class="otherPlanToDate2">
                            <mb-date-picker
                                mbPlaceholderText="{{'staffManager.workHisInformation.label.attributes.toDate2' | translate}}"
                                mbLabelText="{{ 'staffManager.workHisInformation.label.attributes.toDate2' | translate}}"
                                formControlName="otherPlanToDate2"
                            ></mb-date-picker>
                        </div>

                    </div>

                </ng-container>
            </ng-container>
        </extend-form-item>

        <!-- Ghi chú -->
        <div nz-col [nzXs]="24" [nzLg]="24">
            <mb-input-text formControlName="note"
                           [mbIsTextAre]="true"
                           [mbConfig]="{ rows: 3, autoSize: true }"
                           [mbType]="isSubmitted && form.controls['note'].errors ? 'error' : 'default'"
                           [mbShowError]="isSubmitted && form.controls['note'].errors !== null"
                           [mbErrors]="form.controls['note'].errors"
                           [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'staffManager.validate.maxLength' | translate: {'numberLength': '500' }}]"
                           mbPlaceholderText="{{'staffManager.workHisInformation.label.attributes.note' | translate}}"
                           mbLabelText="{{'staffManager.workHisInformation.label.attributes.note' | translate}}"></mb-input-text>
        </div>

        <!-- File đính kèm -->
        <div nz-col [nzXs]="24" [nzLg]="24">
            <label class="input__label">{{'staffManager.label.file' | translate}}</label>
            <nz-upload
                nzType="drag"
                [nzMultiple]="true"
                [(nzFileList)]="fileList" [nzBeforeUpload]="beforeUpload" [nzDownload]="downloadFile"
                [nzRemove]="removeFile">
                <p class="ant-upload-drag-icon">
                    <em nz-icon nzType="inbox"></em>
                </p>
                <p class="ant-upload-text">{{'common.upload.description'|translate}}</p>
            </nz-upload>
        </div>
    </div>
</form>
